$(function () {

    do_polyfill();

    update_sizing();

    var resizeEnd;
    $(window).on('resize', function () {
        clearTimeout(resizeEnd);
        resizeEnd = setTimeout(function () {
            $(window).trigger('resize-end');
        }, 100);
    });

    if (hide_query) {
        img_folder_prefix = "";
    }

    $('body')
        .css('background-image', "url(" + img_folder_prefix + "images/logo_background.png)")

    $('.product-brand')
        .css('background-image', "url(" + img_folder_prefix + "images/logo_command.png)")

    $('.other .header')
        .css('background-image', "url(" + img_folder_prefix + "images/header_image_command_professional.png)")

    $('.professional .header')
        .css('background-image', "url(" + img_folder_prefix + "images/header_image_command_professional.png)")

    $('.separator')
        .css('background-image', "url(" + img_folder_prefix + "images/separator.gif)")
});

function do_polyfill() {
    // polyfill for ie support
    if (!String.prototype.startsWith) {
        String.prototype.startsWith = function (searchString, position) {
            return this.substr(position || 0, searchString.length) === searchString;
        };
    }
    if (!String.prototype.endsWith) {
        String.prototype.endsWith = function (searchString, position) {
            var subjectString = this.toString();
            if (typeof position !== 'number' || !isFinite(position) || Math.floor(position) !== position || position > subjectString.length) {
                position = subjectString.length;
            }
            position -= searchString.length;
            var lastIndex = subjectString.lastIndexOf(searchString, position);
            return lastIndex !== -1 && lastIndex === position;
        };
    }
}

var img_folder_prefix = "../"

var last_reference_width = 0;

$(window).on('resize-end', update_sizing);

var base_width = 960;
var base_height = 200;
var multiplier = 1;
var base_stroke_width_slim = 0.05;
var base_stroke_width_bold = 2 * base_stroke_width_slim;
var base_legend_font_size = 7;
var base_circle_radium = 2;

var width = base_width / multiplier;
var height = base_height / multiplier;
var stroke_width_slim = base_stroke_width_slim * multiplier;
var stroke_width_bold = base_stroke_width_bold * multiplier;
var legend_font_size = base_legend_font_size * multiplier;
var axis_font_size = base_legend_font_size * multiplier;
var axis_stroke_width = base_stroke_width_bold * multiplier;
var circle_radium = base_circle_radium * multiplier;

var is_wide = true;
function narrow_widen()
{
	if (is_wide == true)
	{
		d3.select('#page_container').style("max-width", "1100px");
		is_wide = false;
		update_sizing();
	}
	else
	{
		d3.select('#page_container').style("max-width", "none");
		is_wide = true;
		update_sizing();
	}
}

function update_sizing() {
    var reference_width = $("#divg0").width();
    if (last_reference_width == reference_width)
        return;

    last_reference_width = reference_width;

    if (reference_width <= 670)
        multiplier = 1.3;
    else if (reference_width <= 866)
        multiplier = 1.2;
    else if (reference_width <= 1066)
        multiplier = 1.1;
    else if (reference_width <= 1366)
        multiplier = 1;
    else if (reference_width <= 1616)
        multiplier = 0.9;
    else if (reference_width <= 1766)
        multiplier = 0.8;

    multiplier += 0.05;

    width = base_width / multiplier;
    height = base_height / multiplier;
    stroke_width_slim = base_stroke_width_slim * multiplier;
    stroke_width_bold = base_stroke_width_bold * multiplier;
    legend_font_size = base_legend_font_size * multiplier;
    axis_font_size = base_legend_font_size * multiplier;
    circle_radium = base_circle_radium * multiplier;

    console.debug("SIZE: " + reference_width + ", mult=" + multiplier);

    for (var i = 0, l = arr_parsed.length; i < l; i++) {
        var idSvg = "#g" + i;
        d3.selectAll(idSvg).selectAll('svg').remove();


        render(arr_xRange[i], arr_parsed[i], arr_gId[i], arr_title[i]);
    }
}

var ex_chart;

var arr_xRange = new Array();
var arr_parsed = new Array();
var arr_gId = new Array();
var arr_title = new Array();

function render(xRange, parsed, gId, title) {
    arr_xRange[gId] = xRange;
    arr_parsed[gId] = parsed;
    arr_gId[gId] = gId;
    arr_title[gId] = title;

    var min_pos = 0;
    var max_pos = 0;

    for (var i = 0, l = parsed.length; i < l; i++) {
        if (parsed[i].id === "min")
            min_pos = i;
        if (parsed[i].id === "max")
            max_pos = i;
    }

    var idSvg = "#g" + gId;
    var svg = d3.select(idSvg);

    ex_chart = chart_mgr().zoom(true);

    //svg.attr("width", window.innerWidth).attr("height", window.innerHeight)
    //    .datum(data).call(ex_chart);
    svg.attr("preserveAspectRatio", "xMinYMin meet")
        .attr("viewBox", "0 0 " + width + " " + height)
        .classed("svg-content-responsive", true).data([parsed]).call(ex_chart)

    var divcont = d3.select("#divg" + gId);

    var tcont = d3.select("#t" + gId)
        .style('margin-left', '80px')
        .text(title);

    function resetlegend() {
        d3.select(this.parentNode).selectAll(".focus").style("display", "none");


        svg.select("#leg_date").text("Select time");

        for (var i = 0, l = parsed.length; i < l; i++) {
            var legObj = svg.select("#leg_" + i);
            legObj.text(parsed[i].id);
        }
    }

    function chart_mgr() {
        var margin = { top: 10, bottom: 40, left: 35, right: 0 };
        var xaxis = d3.svg.axis();
        var yaxis = d3.svg.axis();
        var xscale = d3.time.scale();
        var yscale = d3.scale.linear();
        var can_zoom = true;


        var xyzoom = d3.behavior.zoom()
            .x(xscale)
            .y(yscale)
            .on("zoom", can_zoom ? redraw : null);
        var xzoom = d3.behavior.zoom()
            .x(xscale)
            .on("zoom", can_zoom ? redraw : null);
        var yzoom = d3.behavior.zoom()
            .y(yscale)
            .on("zoom", can_zoom ? redraw : null);

        function chart(selection) {
            selection.each(function (data) {
                svg = d3.select(this).selectAll('svg').data([data]);

                svg.enter().append('svg');

                var g = svg.append('g')
                    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

                g.append("defs").append("clipPath")
                    .attr("id", "clip")
                    .append("rect")
                    .attr("width", width - margin.left - margin.right)
                    .attr("height", height - margin.top - margin.bottom);

                // rettangolo attorno al grafico
                //g.append("svg:rect")
                //    .attr("class", "border")
                //    .attr("width", width - margin.left - margin.right)
                //    .attr("height", height - margin.top - margin.bottom)
                //    .style("stroke", "black")
                //    .style("fill", "none");

                g.append("g").attr("class", "xaxis")
                    .attr("transform", "translate(" + 0 + "," + (height - margin.top - margin.bottom) + ")")
                    .style('stroke-width', axis_stroke_width + "em")
                    .style('font-size', axis_font_size + "px")


                var yAxisNodes = g.append("g").attr("class", "yaxis")
                    .style('stroke-width', axis_stroke_width + "em")
                    .style('font-size', axis_font_size + "px")

                g.append("g")
                    .attr("class", "scatter")
                    .attr("clip-path", "url(#clip)");

                g.append("g")
                    .attr("class", "line")
                    .attr("clip-path", "url(#clip)");

                var myzoomxy = g
                    .append("svg:rect")
                    .attr("class", "zoomxy")
                    .attr("width", width - margin.left - margin.right)
                    .attr("height", height - margin.top - margin.bottom)
                    .style("visibility", "hidden")
                    .attr("pointer-events", "all")
                    .call(xyzoom);

                g
                    .append("svg:rect")
                    .attr("class", "zoomx")
                    .attr("width", width - margin.left - margin.right)
                    .attr("height", height - margin.top - margin.bottom)
                    .attr("transform", "translate(" + 0 + "," + (height - margin.top - margin.bottom) + ")")
                    .style("visibility", "hidden")
                    .attr("pointer-events", "all")
                    .call(xzoom);

                g
                    .append("svg:rect")
                    .attr("class", "zoomy")
                    .attr("width", margin.left)
                    .attr("height", height - margin.top - margin.bottom)
                    .attr("transform", "translate(" + -margin.left + "," + 0 + ")")
                    .style("visibility", "hidden")
                    .attr("pointer-events", "all")
                    .call(yzoom);

                var legend_x = width - 140;
                var legend_y = 5;

                var rect = g.append("rect")
                    .attr("x", legend_x - 10)
                    .attr("y", legend_y - 3)
                    .attr("rx", 2)
                    .attr("ry", 2)
                    .attr("width", 113)
                    .attr("height", 10 + 10 * (parsed.length + 1))
                    .style("fill", "white")
                    .style("stroke", "black")
                    .style("stroke-width", stroke_width_slim + "em")
                    .style("opacity", "0.9")

                legend_y += 10;

                g.append("text")
                    .attr("id", "leg_date")
                    .attr("x", legend_x - 7)
                    .attr("y", legend_y - 2)
                    .style("font", legend_font_size + "px sans-serif")
                    .text("Select time")

                for (var i = 0, l = parsed.length; i < l; i++) {
                    legend_y += 10;

                    var circ = g.append("circle");
                    circ.attr("r", circle_radium)
                        .style("fill", palette.get(parsed[i].id))
                        .style("stroke", "transparent")
                        .attr("transform", function (d) { return "translate(" + (legend_x - 4) + "," + (legend_y - 2) + ")"; })

                    var txt = g.append("text");

                    txt.attr("id", "leg_" + i);
                    txt.attr("linenum", i)
                        .on("mouseover", function (d, i, g) {
                            var linenode = svg.selectAll("#" + "line_" + d3.select(this).attr("linenum"));
                            linenode.style("stroke-width", stroke_width_bold + "em");


                            var linenum = d3.select(this).attr("linenum");
                            var currfill = d3.select(this).style("fill");
                            if (currfill == "#bbb" || currfill == "rgb(187, 187, 187)") {
                                svg.selectAll("#focus_" + linenum).style("opacity", 0);
                            }
                            else {
                                svg.selectAll("#focus_" + linenum).style("opacity", 1);
                            }
                        })
                        .on("mouseout", function (d, i, g) {
                            var linenode = svg.selectAll("#" + "line_" + d3.select(this).attr("linenum"));
                            linenode.style("stroke-width", stroke_width_slim + "em");
                        })
                        .on("click", function (d, i, g) {
                            var linenum = d3.select(this).attr("linenum");
                            var currfill = d3.select(this).style("fill");
                            if (currfill == "#bbb" || currfill == "rgb(187, 187, 187)") {
                                d3.select(this).style("fill", palette.get(parsed[linenum].id));
                                svg.selectAll("#line_" + linenum).style("opacity", 1);
                                svg.selectAll("#focus_" + linenum).style("opacity", 1);
                            }
                            else {
                                d3.select(this).style("fill", "#bbb");
                                svg.selectAll("#line_" + linenum).style("opacity", 0);
                                svg.selectAll("#focus_" + linenum).style("opacity", 0);
                            }
                        })
                        .style("font", legend_font_size + "px sans-serif")
                        .style("fill", palette.get(parsed[i].id))
                        .attr("transform", function (d) { return "translate(" + (legend_x) + "," + (legend_y) + ")"; })
                        .text(parsed[i].id);
                }

                // Update the x-axis
                xscale.domain(xRange)
                    .range([0, width - margin.left - margin.right]);

                xaxis.scale(xscale)
                    .orient('bottom')

                // Update the y-scale.
                yscale.domain([
                    d3.min(parsed, function (c) {
                        var min = d3.min(c.values, function (d) { return d.value; });
                        return min;
                    }),
                    d3.max(parsed, function (c) {
                        var max = d3.max(c.values, function (d) { return d.value; });
                        return max;
                    })
                ])
                    .range([height - margin.top - margin.bottom, 0]);

                yaxis.scale(yscale)
                    .orient('left')
                //.selectAll(".tick:not(:first-of-type) line").attr("stroke", "#777").attr("stroke-dasharray", "2,2");

                //
                var spiazza = 10;

                var tip_offset_x = margin.left + spiazza,
                    tip_offset_y = margin.top - spiazza;

                for (var i = 0, l = parsed.length; i < l; i++) {

                    var focus = g.append("g")
                        .attr("id", "focus_" + i)
                        .attr("class", "focus")
                        .attr("transform", "translate(" + margin.left + "," + margin.top + ")")
                        .style("display", "none")

                    // selection circle
                    focus.append("circle")
                        .attr("id", "linecirc_" + i)
                        .attr("r", circle_radium)
                        .style("fill", palette.get(parsed[i].id))
                        .style("stroke", "transparent")
						.attr("pointer-events", "none")
                    //.style("fill", "transparent")
                    //.style("stroke", palette.get(parsed[i].id))

                    //// tooltip text
                    //focus.append("text")
                    //    .attr("class", "tooltip")
                }

                myzoomxy.on("mouseover", function () {
                    d3.select(this.parentNode).selectAll(".focus").style("display", null);
                })
                    //.on("mouseout", resetlegend)
                    .on("mousemove", mousemove);

                //var divcont = d3.select("#divg"+gId);

                //divcont.append("div")
                //    .attr("class", "div.tooltip")
                //    .attr("transform", "translate(" + tip_offset_x + "," + tip_offset_y + ")")

                var bisectDate = d3.bisector(function (d) {
                    return d.time;
                }).left;

                var formatTime = d3.time.format.utc("%Y-%m-%dT%H:%M:%S"/*"%B %d, %Y - "*//*"%c"*/);

                function mousemove() {

                    var mouse_x = d3.mouse(this)[0] + margin.left;
                    //var mouse_x = d3.event.x;
                    if (mouse_x < margin.left)
                        return;

                    var xpos = mouse_x - margin.left;

                    var x0 = xscale.invert(xpos);

                    var d = null;

                    for (var i = 0, l = parsed.length; i < l; i++) {
                        var a = bisectDate(parsed[i].values, x0, 1);

                        var d0 = parsed[i].values[a - 1],
                            d1 = parsed[i].values[a]

                        if (d0 != null && d1 != null) {
                            var used_a = x0 - d0.time > d1.time - x0 ? a : a - 1;
                            var used_d = x0 - d0.time > d1.time - x0 ? d1 : d0;
                            if (i == 0) {
                                d = used_d;
                                var dt = svg.select("#leg_date")

                                dt.text(formatTime(used_d.time) + " [UTC]");
                            }

                            //d3.select(this.parentNode).select("#focus_" + i).select("text").text(d3.format(".3f")(used_d.value)); // per-line text
                            var legObj = svg.select("#leg_" + i);
                            var opacity = 1;
                            var currfill = legObj.style("fill");
                            if (currfill == "#bbb" || currfill == "rgb(187, 187, 187)") {
                                opacity = 0;
                            }

                            var linenum = legObj.attr("linenum");
                            d3.select(this.parentNode).select("#focus_" + linenum)
                                .attr("transform", "translate(" + X(used_d) + "," + Y(used_d) + ")") // move circle
                                .style("opacity", opacity)

                            legObj.text(parsed[linenum].id + ": " + d3.format(".3f")(used_d.value)); // per-line text

                        }
                    }

                    if (d != null) {
                        var pos_x = X(d);
                        var pos_y = Y(d);

                        //d3.selectAll(".focus").attr("transform", "translate(" + pos_x + "," + pos_y + ")");
                        //d3.selectAll(".focus").select("text").text(text);

                        var me = d3.select(this.parentNode);

                        me.selectAll("#vline").remove();

                        var h = me.height;

                        var vline = me.append("line");

                        vline.attr("id", "vline")
                            .style("stroke", "gray")
                            .attr("x1", pos_x)
                            .attr("y1", 0)
                            .attr("x2", pos_x)
                            .attr("y2", height - margin.bottom)
                            .attr("pointer-events", "none");
                    }
                }

                //

                redraw();
            });

            return chart;
        }

        // lines
        var valueline = d3.svg.line()
            .x(function (d) {
                var tmp = X(d)
                return tmp;
            })
            .y(function (d) {
                var tmp = Y(d)
                return tmp;
            })

        function update(i, dataset, curropacity) {

            var currcolor = palette.get(dataset.id);

            // line
            var ls = svg.select("g.line");
            ls.append("svg:path")
                //.transition().ease("linear")
                .attr("id", "line_" + i)
                .attr("class", "line")
                .attr("d", valueline(dataset.values))
                .style("stroke", currcolor)
                .style("stroke-width", stroke_width_slim + "em")
                .style("opacity", curropacity)
				.attr("pointer-events", "none")

            // circles
            //var gs = svg.select("g.scatter");

            //var circle = gs.selectAll(".circ_" + i)
            //    .data(function (d)
            //    {
            //        return d[i].values;
            //    });

            //circle.enter().append("svg:circle")
            //    .attr("class", "points circ_" + i)
            //    .style("fill", "transparent") //.style("fill", "steelblue")
            //    .style("stroke", currcolor)
            //    .attr("r", 1);

            //circle.attr("cx", function (d) {
            //    return X(d);
            //})
            //.attr("cy", function (d) {
            //    return Y(d);
            //});


            //circle.exit().remove();
        }

        function zoom_update() {

            xyzoom = d3.behavior.zoom()
                .x(xscale)
                .y(yscale)
                .on("zoom", can_zoom ? redraw : null);
            xzoom = d3.behavior.zoom()
                .x(xscale)
                .on("zoom", can_zoom ? redraw : null);
            yzoom = d3.behavior.zoom()
                .y(yscale)
                .on("zoom", can_zoom ? redraw : null);

            svg.select('rect.zoomxy').call(xyzoom); // aggiorna il grafico
            svg.select('rect.zoomx').call(xzoom); // aggiorna l'asse x
            svg.select('rect.zoomy').call(yzoom); // aggiorna l'asse y
        }

        function redraw() {
            svg.select('g.xaxis').call(xaxis);
            svg.select('g.yaxis').call(yaxis);

            var ls = svg.select("g.line");
            ls.selectAll("path").remove();

            for (var i = 0, l = parsed.length; i < l; i++) {
                var curropacity = 1;
                var currfill = svg.select("#leg_" + i).style("fill");
                if (currfill == "#bbb" || currfill == "rgb(187, 187, 187)") {
                    curropacity = 0;
                }

                update(i, parsed[i], curropacity);
            }

            svg.select('.zoomxy').call(resetlegend);

            svg.selectAll("#vline").remove();

            for (var i = 0, l = parsed.length; i < l; i++) {
                //var linenum = d3.select(this).attr("linenum");
                //var currfill = d3.select(this).style("fill");
                //if (currfill == "#bbb" || currfill == "rgb(187, 187, 187)") {
                svg.selectAll("#focus_" + i).style("opacity", 0);
                //}
                //else {
                //    svg.selectAll("#focus_" + linenum).style("opacity", 1);
                //}
            }

            zoom_update();
        };

        // X value to scale
        function X(d) {
            return xscale(d.time);
        }

        // Y value to scale
        function Y(d) {
            return yscale(d.value);
        }

        chart.zoom = function (_) {
            if (!arguments.length) return can_zoom;
            can_zoom = _;
            return chart;
        }

        return chart;
    }
}
